#include "queue.h"

void LQ_CreateQueue(LinkedQueue** Queue){
	/* ť   */
	(*Queue) = (LinkedQueue*)malloc(sizeof(LinkedQueue));
	(*Queue)->Front = NULL;
	(*Queue)->Rear = NULL;
	(*Queue)->Count = 0;
}
void LQ_DestoryQueue(LinkedQueue* Queue){
	while(!LQ_IsEmpty(Queue)){
		Node* Popped = LQ_Dequeue(Queue);
		LQ_DestoryNode(Popped);
	}
	/*	ť    */
	free(Queue);
}
Node* LQ_CreateNode(int NewData){
	Node* NewNode = (Node*)malloc(sizeof(Node));
	NewNode->Data = NewData;	/* ͸ Ѵ. */
	NewNode->NextNode = NULL;	/*  忡  ʹ NULL ʱȭѴ. */
	return NewNode;	/*  ּҸ ȯѴ. */
}
void LQ_DestoryNode(Node* _Node){
	free(_Node);
}
void LQ_Enqueue(LinkedQueue* Queue, Node* NewNode){
	if(Queue->Front == NULL){
		Queue->Front = NewNode;
		Queue->Rear = NewNode;
		Queue->Count++;
	}else{
		Queue->Rear->NextNode = NewNode;
		Queue->Rear = NewNode;
		Queue->Count++;
	}
}
Node* LQ_Dequeue(LinkedQueue* Queue){
	/* LQ_Dequeue() Լ ȯ ֻ  */
	Node* Front = Queue->Front;

	if(Queue->Front->NextNode == NULL){
		Queue->Front = NULL;
		Queue->Rear = NULL;
	}else
		Queue->Front = Queue->Front->NextNode;
	Queue->Count--;
	return Front;
}
int LQ_IsEmpty(LinkedQueue* Queue){
	return (Queue->Front == NULL);
}
