#include <stdio.h>
#include <minmax.h>
#include "queue.h"

void FCFS(int (*)[2]);
void RR(int tq,int (*)[2]);
void SJF(int (*)[2]);
void SRT(int (*)[2]);
void HRRN(int (*)[2]);
void MFQ(int,int (*)[2]);
void showScheduilng(char* str,int (*sch)[20]);

int main(){
	//μ ð  񽺽ð
	int process[5][2] = {{0,3},{2,6},{4,4},{6,5},{8,2}};
	int i;
	printf("\n");
	printf("  PID  AT  ST \n");
	for(i=0; i<5; i++){
		printf(" %3d   %2d  %2d \n", i,process[i][0],process[i][1]);
	}
	printf("\n");

	FCFS(process);
	RR(1,process);
	RR(4,process);
	SJF(process);
	SRT(process);
	HRRN(process);
	MFQ(1,process);
	MFQ(2,process);

	printf("32092024  ");
	printf("32091996 ̹ ");
	printf("32092036 ǥ\n");
	printf("32091989  ");
	printf("32121857 Ѽ\n");
	return 0;
}

void MFQ(int qSize,int (*proc)[2]){
	//μ ð  񽺽ð  迭
	int process[5][2];
	// μ 층  迭
	int scheduling[5][20] = {0};
	int i,j,m;					// for loop ̿ 
	int allQEmpty;				//  ť ִ üũϿ   
	int topQCheck = 0;			// ߺ ϱ  
	LinkedQueue* topQueue;		// topQueue ť
	LinkedQueue* middleQueue;	// middleQueue ť
	LinkedQueue* bottomQueue;	// bottomQueue ť
	LinkedQueue* topTempQueue;	// topQueue  ߱   ť
	Node* Popped;				// ť  带   
	int PoppedData;				//   ͸  
	LQ_CreateQueue(&topQueue);
	LQ_CreateQueue(&middleQueue);
	LQ_CreateQueue(&bottomQueue);
	LQ_CreateQueue(&topTempQueue);
	
	for(i=0; i<5; i++){
		process[i][0] = proc[i][0];
		process[i][1] = proc[i][1];
	}


	// Outer For Loop
	for(i=0; i<20; ){ // 20 񽺽ðŭ ݺ

		// For Loop 1
		if( topQCheck == 0 )
			for(j=0; j<5; j++)
				if( process[j][0] == i )
					LQ_Enqueue(topQueue,LQ_CreateNode(j));
		
		topQCheck = 0;
			
		if( !LQ_IsEmpty(topQueue) ){		// topQueue  ʴٸ
			Popped = LQ_Dequeue(topQueue);
			PoppedData = Popped->Data;		// ť (μ ȣ) 
			LQ_DestoryNode(Popped);


			// topQueue  ð(1)ŭ 
			for(j=0; j<qSize/qSize && process[PoppedData][1]; j++){
				process[PoppedData][1]--;
				scheduling[PoppedData][i++] = 1;

				// ϰ  μ ִ Ȯ
				// i  ̹Ƿ ̴ Outer For Loop
				// ݺǸ ť ٽ ߺǾ Ƿ
				// topQCheck 1 ʱȭ
				//  Ͽ  ť  μ 
				for(m=0; m<5; m++)
					if( process[m][0] == i ){
						LQ_Enqueue(topTempQueue,LQ_CreateNode(m));
						if( process[PoppedData][1] == 0 || j+1 == qSize/qSize )
							topQCheck = 1;
					}
			}

			if( LQ_IsEmpty(topQueue) ){ //    topQueue ְ

				allQEmpty = LQ_IsEmpty(middleQueue) && LQ_IsEmpty(bottomQueue);
				
				//   ť  ʴٸ
				//   μ middleQueue 
				if( process[PoppedData][1] > 0 && !allQEmpty)
					LQ_Enqueue(middleQueue, LQ_CreateNode(PoppedData));

				//  ť ִ μ topQueue 
				while( !LQ_IsEmpty(topTempQueue) ){
					Popped = LQ_Dequeue(topTempQueue);
					LQ_Enqueue(topQueue,LQ_CreateNode(Popped->Data));
					LQ_DestoryNode(Popped);
				}

				//   ť ִٸ
				//   μ topQueue ٽ 
				if( process[PoppedData][1] > 0 && allQEmpty)
					LQ_Enqueue(topQueue, LQ_CreateNode(PoppedData));
				
			}else{ // topQueue  ʴٸ
				//  ť  μ topQueue 
				while( !LQ_IsEmpty(topTempQueue) ){
					Popped = LQ_Dequeue(topTempQueue);
					LQ_Enqueue(topQueue,LQ_CreateNode(Popped->Data));
					LQ_DestoryNode(Popped);
				}
				
				//   μ Ÿ ִٸ
				// middleQueue μ 
				if( process[PoppedData][1] > 0 )
					LQ_Enqueue(middleQueue, LQ_CreateNode(PoppedData));
			}

		}else if( !LQ_IsEmpty(middleQueue) ){ // middleQueue  ʴٸ
			Popped = LQ_Dequeue(middleQueue);
			PoppedData = Popped->Data; // ť (μ ȣ)  
			LQ_DestoryNode(Popped);

			// middleQueue  ð(qSize^1)ŭ 
			for(j=0; j<qSize && process[PoppedData][1]; j++){
				process[PoppedData][1]--;
				scheduling[PoppedData][i++] = 1;

				// ϰ  μ ִ Ȯ
				// i  ̹Ƿ ̴ Outer For Loop
				// ݺǸ ť ٽ ߺǾ Ƿ
				// topQCheck 1 ʱȭ
				//  Ͽ  ť  μ 
				for(m=0; m<5; m++)
					if( process[m][0] == i ){
						LQ_Enqueue(topTempQueue,LQ_CreateNode(m));
						if( process[PoppedData][1] == 0 || j+1 == qSize )
							topQCheck = 1;
					}
			}

			
			//  ť  ְ μ ð  ִٸ ٽ middleQueue 
			if( LQ_IsEmpty(middleQueue) && LQ_IsEmpty(bottomQueue) && LQ_IsEmpty(topQueue) ){
				if( process[PoppedData][1] > 0 )
					LQ_Enqueue(middleQueue, LQ_CreateNode(PoppedData));
			}else{ // ׷ ʰ Ÿ  ִٸ bottomQueue 
				if( process[PoppedData][1] > 0 )
					LQ_Enqueue(bottomQueue, LQ_CreateNode(PoppedData));
			}

			// ť ִ  μ
			// topQueue 
			while( !LQ_IsEmpty(topTempQueue) ){
				Popped = LQ_Dequeue(topTempQueue);
				LQ_Enqueue(topQueue,LQ_CreateNode(Popped->Data));
				LQ_DestoryNode(Popped);
			}

		}else if( !LQ_IsEmpty(bottomQueue) ){	// bottomQueue  ʴٸ
			Popped = LQ_Dequeue(bottomQueue);
			PoppedData = Popped->Data;			// ť (μ ȣ) 
			LQ_DestoryNode(Popped);

			// middleQueue  ð(qSize^2)ŭ 
			for(j=0; j<qSize*qSize && process[PoppedData][1]; j++){
				process[PoppedData][1]--;
				scheduling[PoppedData][i++] = 1;

				// ϰ  μ ִ Ȯ
				// i  ̹Ƿ ̴ Outer For Loop
				// ݺǸ ť ٽ ߺǾ Ƿ
				// topQCheck 1 ʱȭ
				// bottomQueue  ٽ bottomQueue Ƿ
				//  μ ٷ topQueue ִ´.
				for(m=0; m<5; m++)
					if( process[m][0] == i ){
						LQ_Enqueue(topQueue,LQ_CreateNode(m));
						if( process[PoppedData][1] == 0 || j+1 == qSize*qSize )
							topQCheck = 1;
					}
			}
			//  μ 񽺽ð ִٸ ٽ bottomQueue 
			if( process[PoppedData][1] > 0 )
				LQ_Enqueue(bottomQueue, LQ_CreateNode(PoppedData));
		}else{
			i++;
		}
	}
	printf("----- q - %d ", qSize);
	showScheduilng("Multilevel Feedback Queue", scheduling);
	LQ_DestoryQueue(topTempQueue);
	LQ_DestoryQueue(bottomQueue);
	LQ_DestoryQueue(middleQueue);
	LQ_DestoryQueue(topQueue);
}

void HRRN(int (*proc)[2]){
	//μ ð  񽺽ð
	int process[5][2];
	// μ 층  迭
	int scheduling[5][20] = {0};
	int sort[5];		// ť ִ  ϱ  迭
	int i,j,k,m;		// for loop ̿ 
	int HRRIndex;		// HRR    μ ε 庯
	double maxHRR;		// sort迭 񱳽 HRRִ밪  
	double HRR;			// HRR   
	int wTime, sTime;	// ð 񽺽ð  

	Node* Popped;		// ť  带   
	LinkedQueue* Queue;	// ḮƮ ť ų  
	LQ_CreateQueue(&Queue);

	for(i=0; i<5; i++){
		process[i][0] = proc[i][0];
		process[i][1] = proc[i][1];
	}

	for(i=0; i<20; ){
		// For Loop 1
		for(j=0; j<5; j++)	
			if( process[j][0] == i ) // Žð(i)   μ(j) üũ
				LQ_Enqueue(Queue,LQ_CreateNode(j));

		if( !LQ_IsEmpty(Queue) ){ // ť ִٸ
			k=0; // k 0 ʱȭ
			
			while( !LQ_IsEmpty(Queue) ){	// ť ִ  (μȣ)
				Popped = LQ_Dequeue(Queue);
				sort[k++] = Popped->Data;	// sort迭 
				LQ_DestoryNode(Popped);
			}

			maxHRR = 0; // HRR ִ밪 0 ʱȭ
			for(j=0; j<k; j++){
				// ܿ ð  ð - ð   
				wTime = i - process[ sort[j] ][0];
				//  Ÿ 
				sTime = process[ sort[j] ][1];
				// HRR 
				HRR = ((double)wTime + (double)sTime) / (double)sTime;
				if( maxHRR < HRR ){ // ִ HRR Ͽ ũٸ ε   
					HRRIndex = j;
					maxHRR = HRR;
				}
			}

			maxHRR = process[ sort[HRRIndex] ][1]; // Ÿ 
			for(j=0; j < maxHRR; j++){ //  ŸӸŭ 
				scheduling[ sort[HRRIndex] ][i++] = 1;

				// For Loop 1 ߺ  
				if( j+1 < maxHRR )
					for(m=0; m<5; m++)
						if( process[m][0] == i )
							LQ_Enqueue(Queue,LQ_CreateNode(m));
			}

			// ִ HRR ε  ť   μ ٽ ť 
			for(j=0; j<k; j++){
				if( j != HRRIndex )
					LQ_Enqueue(Queue,LQ_CreateNode(sort[j]));
			}
		}else{
			// ť ִٸ 񽺽ð 
			i++;
		}
	}
	showScheduilng("----- Highest Response Ratio Next", scheduling);
	LQ_DestoryQueue(Queue);
}


void SRT(int (*proc)[2]){
	//μ ð  񽺽ð
	int process[5][2];
	// μ 층  迭
	int scheduling[5][20] = {0};
	int sort[5];		// ť ִ  ϱ  迭
	int i,j,k;			// for loop ̿ 
	int minSortSTIndex;	// sort迭 ּ 񽺽ð ε ϱ  
	int minST;			// sort迭 񱳽 ּ 񽺽ð ϱ  

	Node* Popped;			// ť  带   
	LinkedQueue* Queue;		// ḮƮ ť ų  
	LQ_CreateQueue(&Queue);

	for(i=0; i<5; i++){
		process[i][0] = proc[i][0];
		process[i][1] = proc[i][1];
	}

	for(i=0; i<20; i++){
		for(j=0; j<5; j++)
			if( process[j][0] == i ) // Žð(i)   μ(j) üũ
				LQ_Enqueue(Queue,LQ_CreateNode(j));

		if( !LQ_IsEmpty(Queue) ){ // ť  ʴٸ
			k=0;

			while( !LQ_IsEmpty(Queue) ){	// ť ִ  (μȣ)
				Popped = LQ_Dequeue(Queue);
				sort[k++] = Popped->Data;	// sort迭 
				LQ_DestoryNode(Popped);
			}
			
			minST = INT_MAX;	// minST ʱȭ
			for(j=0; j<k; j++)	// ּҼ񽺽ð ּҼ ε ã
				if( minST > process[ sort[j] ][1] ){
					minSortSTIndex = j;
					minST = process[ sort[j] ][1];
				}
			
			//ּ ð μ 1 
			scheduling[ sort[minSortSTIndex] ][i] = 1;
			//ּ ð μ  ð 1 ҽŴ
			process[ sort[minSortSTIndex] ][1]--;


			// ť   μ 
			// ܿ  ð 0 ƴ  ٽ ť 
			for(j=0; j<k; j++)
				if( process[ sort[j] ][1] != 0 )
					LQ_Enqueue(Queue,LQ_CreateNode(sort[j]));
		}
	}

	showScheduilng("----- Shortest Remaining Time", scheduling);
	LQ_DestoryQueue(Queue);
}


void SJF(int (*proc)[2]){
	//μ ð  񽺽ð
	int process[5][2];
	// μ 층  迭
	int scheduling[5][20] = {0};
	int sort[5];		// ť ִ  ϱ  迭
	int minSTSortIndex;	// sort迭 ּ 񽺽ð ε ϱ  
	int minST;			// sort迭 񱳽 ּ 񽺽ð ϱ  
	int i,j,k,m;		// for loop ̿ 

	Node* Popped;		// ť  带    
	LinkedQueue* Queue; // ḮƮ ť ų  
	LQ_CreateQueue(&Queue);

	for(i=0; i<5; i++){
		process[i][0] = proc[i][0];
		process[i][1] = proc[i][1];
	}

	for(i=0; i<20; ){

		// For Loop 1
		for(j=0; j<5; j++)
			if( process[j][0] == i ) // Žð(i)   μ(j) üũ
				LQ_Enqueue(Queue, LQ_CreateNode(j));

		if( !LQ_IsEmpty(Queue) ){ // ť  ʴٸ
			k = 0; // k 0 ʱȭ
			while( !LQ_IsEmpty(Queue) ){	// ť ִ  (μȣ)
				Popped = LQ_Dequeue(Queue);
				sort[k++] = Popped->Data;	// sort迭 
				LQ_DestoryNode(Popped);
			}

			minST = INT_MAX;	// minST ʱȭ
			minSTSortIndex = 0;	// ε 0 ʱȭ


			for(j=0; j<k; j++) // ּҼ񽺽ð ּҼ ε ã
				if( minST > process[ sort[j] ][1] ){
					minST = process[ sort[j] ][1];
					minSTSortIndex = j;
				}

			// ּ 񽺽ð μ 񽺽ðŭ ݺ
			for(j=0; j < process[ sort[minSTSortIndex] ][1]; j++){
				scheduling[ sort[minSTSortIndex] ][i++] = 1;

				// 񽺵Ǵ  μ Ȯϱ  ݺ
				// For Loop 1 ߺ    
				if( j+1 < process[ sort[minSTSortIndex] ][1] )
					for(m=0; m<5; m++)
						if( process[m][0] == i )
							LQ_Enqueue(Queue, LQ_CreateNode(m));
			}

			// ť  񽺵  μ ٽ ť 
			for(j=0; j<k; j++)
				//ּ 񽺽ð ε  ǾǷ ٽ ť  
				if( j != minSTSortIndex )
					LQ_Enqueue(Queue, LQ_CreateNode( sort[j] ) );
		}else{
			 // ť ִٸ  ð 
			 i++;
		}
	}

	showScheduilng("----- Shortest Job First", scheduling);
	LQ_DestoryQueue(Queue);
}

void RR(int timeQT,int (*proc)[2]){
	//μ ð  񽺽ð
	int process[5][2];
	// μ 층  迭
	int scheduling[5][20] = {0};
	int i,j,k;			// for loop ̿ 
	int STCheck = 0;	// ܿ Ÿ Ȯ 
	int PoppedData;		// ť      
	Node* Popped;		// ť  带   
	LinkedQueue* Queue; // ḮƮ ť ų  
	LQ_CreateQueue(&Queue); // ť 

	for(i=0; i<5; i++){
		process[i][0] = proc[i][0];
		process[i][1] = proc[i][1];
	}
	
	for(i=0; i<20; ){  //  20 ŭ  ð  ݺ

		// For Loop 1
		for(j=0; j<5; j++) // Žð(i)   μ(j) üũ
			if( process[j][0] == i )
				LQ_Enqueue(Queue, LQ_CreateNode(j));
		
		//   μ Ÿ 
		// ٽ ť .
		if( STCheck == 1 )
			LQ_Enqueue(Queue, LQ_CreateNode(PoppedData));

		if( !LQ_IsEmpty(Queue) ){		//ť  ʴٸ
			Popped = LQ_Dequeue(Queue);	// ť 带 ϰ
			PoppedData = Popped->Data;	//    (μ ȣ) ϰ
			LQ_DestoryNode(Popped);		//  带 ޸𸮿 
			STCheck = 1;				// Ÿ ִٰ 
			
			for(j=0; j<timeQT; j++){ // ŸҸŭ 
				scheduling[ PoppedData ][i++] = 1;
				process[ PoppedData ][1]--; // μ ܿ 񽺽ð 1
				
				// For Loop 1 ߺ ϱ  ǹ
				if( j+1 < timeQT && process[ PoppedData ][1] > 0)
					for(k=0; k<5; k++)
						if( process[k][0] == i )
							LQ_Enqueue(Queue, LQ_CreateNode(k));
				
				// μ ܿ 񽺽ð ٸ STCheck 0 ٲٰ break;
				if( process[ PoppedData ][1] == 0 ){ 
					STCheck = 0;
					break;
				}
			}
		}else{
			// ť ִٸ  ð 
			i++;
		}
	}
	printf("----- Time Quantum %d ",timeQT);
	showScheduilng("Round Robin", scheduling);
}

void FCFS(int (*proc)[2]){
	//μ ð  񽺽ð
	int process[5][2];
	// μ 층  迭
	int scheduling[5][20]={0};
	int i,j,m;					// for loop ̿ 
	int PoppedData;				// ť      
	Node* Popped;				// ť  带   
	LinkedQueue* Queue;			// ḮƮ ť ų  
	LQ_CreateQueue(&Queue);		// ť 

	for(i=0; i<5; i++){
		process[i][0] = proc[i][0];
		process[i][1] = proc[i][1];
	}
	
	for(i=0; i<20;){ //  20 ŭ  ð  ݺ

		//For Loop 1
		for(j=0; j<5; j++) // Žð(i)   μ(j) üũ
			if( process[j][0] == i ) 
				LQ_Enqueue(Queue, LQ_CreateNode(j) );

		
		if( !LQ_IsEmpty(Queue) ){ // ť  ʴٸ
			Popped = LQ_Dequeue(Queue);	// ť 带 ϰ
			PoppedData = Popped->Data;	//    (μ ȣ) ϰ
			LQ_DestoryNode(Popped);		//  带 ޸𸮿 

			 // ش μ 񽺽ðŭ 
			for(j=0; j<process[PoppedData][1]; j++){
				//층 ش μ ð ġ 1  
				scheduling[PoppedData][i++] = 1;
				
				// μ 񽺵Ǵ  ϴ μ ֳ Ȯ
				// 񽺸  ħ ÿ  μ ִٸ
				// For Loop 1 ߺ Ͱ Ƿ
				// μ  Ǳ ٷ   μ üũ
				if( j+1 < process[PoppedData][1] )
					for(m=0; m<5; m++)
						if( process[m][0] == i ) // ið  μ ִٸ
							LQ_Enqueue(Queue, LQ_CreateNode(m) ); // ť 
			}
		}else{
			// ť ִٸ 񽺽ð 1
			i++;
		}
	}

	showScheduilng("----- First Come First Serve",scheduling);
}


void showScheduilng(char* str,int (*sch)[20]){
	int i,j;
	printf("%s\n", str);
	for(i=0; i<5; i++){
		switch(i){
			case 0 : printf("0 ");
				break;
			case 1 : printf("1 ");
				break;
			case 2 : printf("2 ");
				break;
			case 3 : printf("3 ");
				break;
			case 4 : printf("4 ");
				break;
		}
		for(j=0; j<20; j++){
			if( sch[i][j] == 0 )
				printf("");
			else
				printf("");
		}
		printf("\n");
	}
}